//+------------------------------------------------------------------+
//|                                                 MA_vanya_rvm.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                                          Profi_R |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Yellow
#property indicator_color2 Gold
#property indicator_color3 Aqua
#property indicator_color4 DeepSkyBlue
#property indicator_color5 Blue
#property indicator_color6 Violet
#property indicator_color7 DeepPink
#property indicator_color8 Red

//---- input parameters
extern int MAPeriod=48;
extern int Step=34;
extern int Shift_cur=0;
//---- buffers
double Buf0[];
double Buf1[];
double Buf2[];
double Buf3[];
double Buf4[];
double Buf5[];
double Buf6[];
double Buf7[];
//---- var
int GShift;
string iname;
datetime ltime;
double lH,lL;
int lBars;

//+-------------------------------------------------------------------------------------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+-------------------------------------------------------------------------------------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexStyle(7,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Buf0);
   SetIndexBuffer(1,Buf1);
   SetIndexBuffer(2,Buf2);
   SetIndexBuffer(3,Buf3);
   SetIndexBuffer(4,Buf4);
   SetIndexBuffer(5,Buf5);
   SetIndexBuffer(6,Buf6);
   SetIndexBuffer(7,Buf7);
   SetIndexEmptyValue(0,-1);
   SetIndexEmptyValue(1,-1);
   SetIndexEmptyValue(2,-1);
   SetIndexEmptyValue(3,-1);
   SetIndexEmptyValue(4,-1);
   SetIndexEmptyValue(5,-1);
   SetIndexEmptyValue(6,-1);
   SetIndexEmptyValue(7,-1);
   GShift=MAPeriod+Shift_cur;
   SetIndexDrawBegin(0,GShift);
   SetIndexDrawBegin(1,GShift);
   SetIndexDrawBegin(2,GShift);
   SetIndexDrawBegin(3,GShift);
   SetIndexDrawBegin(4,GShift);
   SetIndexDrawBegin(5,GShift);
   SetIndexDrawBegin(6,GShift);
   SetIndexDrawBegin(7,GShift);
   iname="MA_vanya_rvm("+MAPeriod+","+Shift_cur+")";
   IndicatorShortName(iname);
//----
   return(0);
  }
//+-------------------------------------------------------------------------------------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+-------------------------------------------------------------------------------------------------------------------------------------------------+
int start()
{
   int counted_bars,limit,cb;
   double dif;
   int lab;
//----
   if( Time[0]>ltime || Bars>lBars )
   {
      counted_bars=IndicatorCounted();
      //    
      if( counted_bars<0 || Bars<GShift )
      {
         return(0);
      }
      else
      {
         if( counted_bars>0 && Bars-counted_bars<3 )
         {
            counted_bars++;
            limit=Bars-counted_bars;
            lBars=Bars;
         }
         else
         {
            //  
            limit=Bars-GShift;
            lBars=Bars;
         }
      }
      ltime=Time[0];
      lH=-1;
      lL=-1;
   }
   
   //    
   if( !GreaterDoubles(High[0],lH,Digits) && !GreaterDoubles(lL,Low[0],Digits) )
   {
      return(0);
   }
   else
   {
      lH=High[0];
      lL=Low[0];
   }
   
   for( cb=limit;cb>=0;cb-- )
   {
      // 
      dif=MathAbs((High[cb+Shift_cur]+Low[cb+Shift_cur]-High[cb+GShift-1]-Low[cb+GShift-1])/2);
      dif=dif/Point-1;
      lab=MathFloor(dif/Step)+1;
      
      switch(lab)
      {
         case 1: Buf0[cb]=Low[cb]; Buf1[cb]=High[cb];
                 break;
         case 2: Buf0[cb]=High[cb]; Buf1[cb]=Low[cb];
                 break;
         case 3: Buf2[cb]=Low[cb]; Buf3[cb]=High[cb];
                 break;
         case 4: Buf2[cb]=High[cb]; Buf3[cb]=Low[cb];
                 break;
         case 5: Buf4[cb]=Low[cb]; Buf5[cb]=High[cb];
                 break;
         case 6: Buf4[cb]=High[cb]; Buf5[cb]=Low[cb];
                 break;
         case 7: Buf6[cb]=Low[cb]; Buf7[cb]=High[cb];
                 break;
         default: Buf6[cb]=High[cb]; Buf7[cb]=Low[cb];
                 break;
      }
   }
//----
   return(0);
}
//+-------------------------------------------------------------------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------+
int deinit()
{
//----
//----
   return(0);
}
//+---------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                |
//+---------------------------------------------------------------------------------------------------------------------------------------------------+
bool GreaterDoubles(double number1,double number2,int dig)
{
   if(NormalizeDouble(number1-number2,dig)>0) return(true);
   else return(false);
}
//=====================================================================================================================================================

